function UpdateKeys()
	local OldButtonByte = ButtonByte
	local OldDPadByte = DPadByte

	ButtonByte = ( love.keyboard.isDown( "f" ) and band( ButtonByte, (15 - 8) )  or bor( ButtonByte, 8 ) )
	ButtonByte = ( love.keyboard.isDown( "d" ) and band( ButtonByte, (15 - 4) )  or bor( ButtonByte, 4 ) ) 
	ButtonByte = ( love.keyboard.isDown( "a" ) and band( ButtonByte, (15 - 2) )  or bor( ButtonByte, 2 ) )
	ButtonByte = ( love.keyboard.isDown( "s" ) and band( ButtonByte, (15 - 1) )  or bor( ButtonByte, 1 ) ) 

	DPadByte = ( love.keyboard.isDown( "down" ) and    band( DPadByte, (15 - 8) )  or bor( DPadByte, 8 ) ) 
	DPadByte = ( love.keyboard.isDown( "up" ) and  band( DPadByte, (15 - 4) )  or bor( DPadByte, 4 ) )
	DPadByte = ( love.keyboard.isDown( "left" ) and  band( DPadByte, (15 - 2) )  or bor( DPadByte, 2 ) ) 
	DPadByte = ( love.keyboard.isDown( "right" ) and band( DPadByte, (15 - 1) )  or bor( DPadByte, 1 ) ) 

	if ButtonByte ~= OldButtonByte or DPadBye ~= OldDPadByte then
		IF = bor( IF, 16 )
	end
end

function RestartJoypad()
	-- 
	DPadByte = 0xF
	ButtonByte = 0xF

	SelectButtonKeys = true
	SelectDirectionKeys = false
end

--- JOYP
MRead[ 0xFF00 ] = function(  Addr )
	if SelectDirectionKeys then
		return ButtonByte + (SelectDirectionKeys and 16 or 0) + (SelectButtonKeys and 32 or 0)
	elseif SelectButtonKeys then
		return DPadByte + (SelectDirectionKeys and 16 or 0) + (SelectButtonKeys and 32 or 0)
	end
end

MWrite[ 0xFF00 ] = function(  Addr, Data )
	SelectDirectionKeys = band(Data, 16) == 16 
	SelectButtonKeys = band(Data, 32) == 32
end
