require "gmb_opcodes"
require "gmb_cb_opcodes"
require "gmb_memory"
require "gameboy"
require "gmb_gpu"
require "gmb_interupts"
require "gmb_timers"
require "gmb_joypad"
bit = require 'numberlua'
band = bit.band
bor = bit.bor
bxor = bit.bxor
bshr = bit.rshift
bshl = bit.lshift

local canvas=nil

function love.load()
	Restart()
	love.graphics.setMode( 800, 600, false, false, 0 )

	if (love.graphics.newCanvas) then
		canvas = love.graphics.newCanvas( 256, 256 )
		canvas:setFilter("nearest", "nearest")
	else
		canvas = love.graphics.newFramebuffer( 256, 256 )
		canvas:setFilter("nearest", "nearest")
	end
end

function love.update(dt) 
end

function love.draw()
	--for q = 1, 100000 do 

		--if C and A then Step() end

	--end

	--Think()
	if (love.graphics.setCanvas) then
		love.graphics.setCanvas( canvas )
	else
		love.graphics.setRenderTarget( canvas )
	end

	UpdateKeys()
	Think()
	--GPUDraw2()

	if (love.graphics.setCanvas) then
		love.graphics.setCanvas()
	else
		love.graphics.setRenderTarget()
	end
--	love.graphics.setBackgroundColor(255, 255, 255, 255)
--	love.graphics.clear()
	love.graphics.setColor(255, 255, 255, 255)

--	love.graphics.setBlendMode( "premultiplied" )
	love.graphics.draw(canvas, 10, 10, 0, 3, 3)
--	love.graphics.setBlendMode( "alpha" )

    if A then love.graphics.print( A, 600,310 ) end
    love.graphics.print( B, 600,325 )
    if C then love.graphics.print( C, 600,340 ) end
    love.graphics.print( D, 600,355 )
    love.graphics.print( E, 600,370 )
    love.graphics.print( H, 600,385 )
    love.graphics.print( L, 600,400 )
    love.graphics.print( string.format( "%X", PC), 600,430 )
    love.graphics.print( ScrollX, 600,460 )
    love.graphics.print( ScrollY, 600,475 )
    love.graphics.setCaption( love.timer.getFPS() .. " FPS" )
end
